#!/usr/bin/zsh -f
# -*- shell-script -*-
PS4='(%x:%I): [%?] zsh+
'
setopt shwordsplit ksharrays

export srcdir=/src/external-vcs/github/rocky/zshdb/test/integration
[ -z "$SH" ] && export SH=/usr/bin/zsh

export top_builddir=/src/external-vcs/github/rocky/zshdb
export top_srcdir=/src/external-vcs/github/rocky/zshdb
export abs_top_srcdir=/src/external-vcs/github/rocky/zshdb
export host_os=@host_os@

check_output() {
  typeset testfile="$1"
  typeset rightfile="$2"
  # Bourne sh
  # set -o noglob

  /usr/bin/diff  -w --unified "$testfile" "$rightfile" && rm -f "$testfile"
  return $?
}

# Run the debugger on test program $1 with (optional) debugger options $2
# using commandfile $3. We assume $TOP_BUILDDIR, $TOP_SRCDIR and
# $TEST_NAME have been set previously
run_debugger() {
  set -o shwordsplit
  typeset debugged_script="$1"
  typeset dbg_opts
  dbg_opts=${2:-"-L ${top_srcdir} -B -q --no-init --no-highlight"}
  [[ -z $short_test_name ]] && short_test_name=$TEST_NAME
  typeset cmdfile=${3:-"${top_srcdir}/test/data/${short_test_name}.cmd"}
  $SH -- ${top_builddir}/zshdb $dbg_opts -x "$cmdfile" "$debugged_script" $ARGS
}

ARGS=''

# Some tests-* scripts use the below
TEST_FILE="${top_builddir}/test/integration/${TEST_NAME}.check"
RIGHT_FILE="${top_srcdir}/test/data/${TEST_NAME}.right"
TEST_FILTERED_FILE="/tmp/${TEST_NAME}-filtered.check"
RIGHT_FILTERED_FILE="/tmp/${TEST_NAME}-filtered.right"

run_test_check() {
    short_script_name=${1:-$TEST_NAME}
    short_test_name=${2:-$TEST_NAME}

    # Reassign variables to allow overrides via the above parameters
    TEST_FILE="${top_builddir}/test/integration/${short_test_name}.check"
    RIGHT_FILE="${top_srcdir}/test/data/${short_test_name}.right"
    TEST_FILTERED_FILE="/tmp/${short_test_name}-filtered.check"
    RIGHT_FILTERED_FILE="/tmp/${short_test_name}-filtered.right"

    debugged_script="${top_srcdir}/test/example/${short_script_name}.sh"
    [[ ! -r $debugged_script ]] && \
	debugged_script="${top_builddir}/test/example/${short_script_name}.sh"
    if [[ -z "$srcdir" ]] ; then
	print -r -- "You need to set srcdir before running this."
	exit 10
    fi
    (cd $srcdir && run_debugger "$debugged_script" 2>&1 >"$TEST_FILE" </dev/null)
    check_output "$TEST_FILE" "$RIGHT_FILE"
    # Return code tells testing mechanism whether passed or not.
    return $?
}
