#!/usr/bin/zsh
# -*- shell-script -*-
# Test journaling routines
test_journal()
{
    typeset -i var
    # Start off with a clean slate
    _Dbg_erase_journals
    [[ ! -f $_Dbg_journal ]]
    assertEquals 0 "$?"

    # Set a value to var via eval:
    _Dbg_write_journal_eval "var=5"
    assertEquals '5' "$var"

    var=10
    # Should do nothing since we shouldn't be in a subshell
    _Dbg_source_journal
    assertEquals '10' "$var"

    # Now go into a subshell and try again
    ( _Dbg_write_journal_eval "var=5" )
    _Dbg_source_journal
    assertEquals '5' "$var"

    # But since we're not in a subshell not journal file should
    # now not exist
    [[ ! -f $_Dbg_journal ]]
    assertEquals 0 "$?"
}


if [ '/src/external-vcs/github/rocky/zshdb' = '' ] ; then
  echo "Something is wrong: abs_top_srcdir is not set."
 exit 1
fi

abs_top_srcdir=/src/external-vcs/github/rocky/zshdb
# Make sure /src/external-vcs/github/rocky/zshdb has a trailing slash
abs_top_srcdir=${abs_top_srcdir%%/}/
. ${abs_top_srcdir}test/unit/helper.sh
. $abs_top_srcdir/dbg-pre.sh
. $abs_top_srcdir/lib/journal.sh
set -- # reset $# so shunit2 doesn't get confused.

SHUNIT_PARENT=$0

[[ 0 == ${#funcfiletrace[@]} ]] && . ${shunit_file}
