#!/usr/bin/zsh
# -*- shell-script -*-
PS4='(%x:%I): [%?] zsh+ 
'

setopt ksharrays

test_lib_shell_filter_typeset() {
    local testing
    typeset -r read_only='abc'
    typeset -i i=0
    z=(a b c)
    test_expect=('PATH' 10 'i' 0 'read_only' 1 'testing' 0 'CDPATH' 10 'z' 0)
    for ((i=0; i<${#test_expect[@]}; i+=2)) ; do 
	expected_rc=${test_expect[i+1]}
	var_set_cmd=$(_Dbg_shell_variable_typeset ${test_expect[i]})
	rc=$?
	if ((expected_rc <= 1)); then
	    assertEquals $expected_rc $rc
	else
	    assertTrue 0
	fi
    done

}

if [ /src/external-vcs/github/rocky/zshdb = '' ] ; then
  echo "Something is wrong abs_top_srcdir is not set."
 exit 1
fi

abs_top_srcdir=/src/external-vcs/github/rocky/zshdb
# Make sure @top_abs_srcdir@ has a trailing slash
abs_top_srcdir=${abs_top_srcdir%%/}/
. ${abs_top_srcdir}test/unit/helper.sh
. ${abs_top_srcdir}lib/shell.sh
set -- # reset $# so shunit2 doesn't get confused.

SHUNIT_PARENT=$0

[[ 0 == ${#funcfiletrace[@]} ]] && . ${shunit_file}
