#!/usr/bin/zsh
# -*- shell-script -*-

do_test()
{
    file1=$(_Dbg_expand_filename $1)
    assertTrue 'Should not have an error expanding $1' "$?"
    file2=$(_Dbg_expand_filename $2)
    assertEquals "$file1" "$file2"

}
test_pre_expand_filename()
{
    do_test test-pre ./test-pre
    do_test "$PWD/" "${PWD}/."
    do_test /tmp /tmp
    file1=$(echo ~)
    do_test "$file1" ~
}

test_pre_do_show_version()
{
    # Name we refer to ourselves by
    typeset _Dbg_debugger_name='zshdb'
    # The release name we are configured to run under.
    typeset _Dbg_release='0.92'

    version_string=$(_Dbg_do_show_version)
    assertEquals "zshdb, release 0.92" "$version_string"
}

if [ '/src/external-vcs/github/rocky/zshdb' = '' ] ; then
  echo "Something is wrong abs_top_srcdir is not set."
 exit 1
fi
abs_top_srcdir=/src/external-vcs/github/rocky/zshdb
# Make sure /src/external-vcs/github/rocky/zshdb has a trailing slash
abs_top_srcdir=${abs_top_srcdir%%/}/
_Dbg_libdir=$abs_top_srcdir
. ${abs_top_srcdir}test/unit/helper.sh
. ${abs_top_srcdir}/dbg-pre.sh
_Dbg_set_highlight=''
set -- # reset $# so shunit2 doesn't get confused.

SHUNIT_PARENT=$0

[[ 0 == ${#funcfiletrace[@]} ]] && . ${shunit_file}
